#!/usr/bin/perl

# This script portion is *ix specific.
# It will only work on *ix with perl installed

IRC::register("GemX: *ix specific functions and workarounds", "$gx::ver", "", "");

IRC::add_command_handler("playsound", "play_requested_sound");
IRC::add_command_handler("amp", "xmms_handler");
IRC::add_command_handler("pm123", "xmms_handler");
IRC::add_command_handler("pm", "xmms_handler");

use strict;
use Xmms ();
use Xmms::Remote ();
use IO::File;
my $remote = Xmms::Remote->new;

my $mp3file;

&get_sysinfo;

my %playlist = undef;		# global playlist for object state
my $JAMMING = "";		# i don't like catchphrases myself  :)
my %state;

sub play_requested_sound {
     IRC::print("$gx::sol Bogus function called!\n");
     IRC::print("$gx::sol Go to Settings -> CTCP-replies\n");
     IRC::print("$gx::sol Choose under Name the function SOUND\n");
     IRC::print("$gx::sol and Delete the CTCP-reply for it\n");
     IRC::print("$gx::sol \n");
     IRC::print("$gx::sol Dummy-Funktion aufgerufen!\n");
     IRC::print("$gx::sol Gehen Sie auf Einstellungen -> CTCP-Antworten\n");
     IRC::print("$gx::sol Wählen Sie unter Name die Funktion SOUND\n");
     IRC::print("$gx::sol und Deleten Sie diese!\n");
}


sub get_sysinfo {
	$gx::sysinfo::system=`uname -s`;
	$gx::sysinfo::version=`uname -r`;
	$gx::sysinfo::arch=`uname -m`;

	$gx::sysinfo::clock="";

	$gx::sysinfo::cpustring="";

	chomp($gx::sysinfo::system);
	chomp($gx::sysinfo::version);
	chomp($gx::sysinfo::arch);

	$gx::sysinfo::cpustring=$gx::sysinfo::arch;

	return 1;
}

sub gx::get_uptime {
	return 0;
}


sub xmms_handler {
	my $cmdline=shift(@_);
	chomp $cmdline;
	my @tmp=split /\s/, $cmdline;
	my $cmd=uc($tmp[0]);
	my $chan="";
	if ($cmd eq "") {
		$cmd="/ME";
		$cmdline="/me";
	}

	if (($cmd eq "/SEND") && $tmp[1] && $mp3file) {
		IRC::command("/DCC PSEND $tmp[1] \"$mp3file\"");
	} elsif (($cmd eq "/SEND") && $mp3file) {
		IRC::print("$gx::sol You need to specify a target user");
	} elsif (($cmd eq "/SEND") && $tmp[1]) {
		IRC::print("$gx::sol You need to have announced an MP3 before");
	} elsif ($cmd eq "/SEND") {
		IRC::print("$gx::sol You need to specify a target user and have announced an MP3 before");
	} elsif ($cmd eq "/ME" or $cmd eq "/NOTICE" or $cmd eq "/MSG") {
		if ($remote->is_playing()) {
			srand;
			my $songnum=$remote->get_playlist_pos();
			$mp3file=$remote->get_playlist_file();
			my $listlength=$remote->get_playlist_length();
			my $song=gx::convert_to_local($remote->get_playlist_title());
			my $currentpos=$remote->get_output_time();
			my $totallength=$remote->get_playlist_time($songnum);
			$currentpos=($currentpos / 1000);
			$totallength=($totallength / 1000);
	                my ($bitrate, $samplerate, $channels)=$remote->get_info;
			$bitrate=$bitrate / 1000;
			$samplerate=$samplerate / 1000;
			my ($currmin,$currsec)=&GemX::ConvertSecToMin($currentpos);
			my ($totalmin,$totalsec)=&GemX::ConvertSecToMin($totallength);
			my $chan = IRC::get_info(2);
			my $lang='';
			my $indx=rand @gx::actionsamp;
			my $text=$gx::actionsamp[$indx];
			foreach my $elt (@gx::chan_de) {
				if (lc($elt) eq lc(substr($chan,(length($elt)-2*length($elt))))) {
					$indx=rand @gx::actionsamp_de;
					$text=$gx::actionsamp_de[$indx];
					last;
				}
			}
			foreach my $elt (@gx::chan_en) {
				if (lc($elt) eq lc(substr($chan,(length($elt)-2*length($elt))))) {
					$indx=rand @gx::actionsamp_en;
					$text=$gx::actionsamp_en[$indx];
					last;
				}
			}
			foreach my $elt (@gx::chan_nl) {
				if (lc($elt) eq lc(substr($chan,(length($elt)-2*length($elt))))) {
					$indx=rand @gx::actionsamp_nl;
					$text=$gx::actionsamp_nl[$indx];
					last;
				}
			}
			$totallength=-1 if ($totallength == "0");
			my $percent=int($currentpos/(10*$totallength));
        	        if ($totallength < $currentpos) {
				IRC::command("/me $text: $song ($currmin:$currsec) [\002$bitrate\002kbit/s \002$samplerate\002kHz]");
			} else {
				IRC::command("/me $text ".($songnum+1)."/$listlength: $song ($currmin:$currsec\/$totalmin:$totalsec) [\002$bitrate\002kbit/s \002$samplerate\002kHz]");
			}
		}
	} elsif ($cmd eq "WHATISPLAYING" or $cmd eq "STATUS") {
		if (!$remote->is_playing()) {
			IRC::print("$gx::sol XMMS stopped...") if (GemX::GetGlobalSet("LANGUAGE") eq "EN");
			IRC::print("$gx::sol XMMS gestoppt...") if (GemX::GetGlobalSet("LANGUAGE") eq "DE");
		} elsif (($remote->is_playing()) && ($remote->is_paused())) {
			my $songnum=$remote->get_playlist_pos();
			my $listlength=$remote->get_playlist_length();
			my $song=gx::convert_to_local($remote->get_playlist_title());

			my $currentpos=(($remote->get_output_time()) % 1000);
			my $totallength=180000;
	                my ($bitrate, $samplerate, $channels)=$remote->get_info;
			$bitrate=$bitrate / 1000;
			$samplerate=$samplerate / 1000;
			my $percent=int($currentpos/(10*$totallength));
			my ($totalmin,$totalsec)=&GemX::ConvertSecToMin($totallength);
			IRC::print("$gx::sol Paused on #".($songnum+1)."/$listlength: $song ($percent% of $totalmin:$totalsec) [\002$bitrate\002kbit/s \002$samplerate\002kHz]") if (GemX::GetGlobalSet("LANGUAGE") eq "EN");
			IRC::print("$gx::sol Pausiere bei #".($songnum+1)."/$listlength: $song ($percent% of $totalmin:$totalsec) [\002$bitrate\002kbit/s \002$samplerate\002kHz]") if (GemX::GetGlobalSet("LANGUAGE") eq "DE");
		} elsif ($remote->is_playing()) {
			my $songnum=$remote->get_playlist_pos();
			my $listlength=$remote->get_playlist_length();
			my $song=gx::convert_to_local($remote->get_playlist_title());

			my $currentpos=(($remote->get_output_time()) % 1000);
			my $totallength=180000;
	                my ($bitrate, $samplerate, $channels)=$remote->get_info;
			$bitrate=$bitrate / 1000;
			$samplerate=$samplerate / 1000;
			my $percent=int($currentpos/(10*$totallength));
			my ($totalmin,$totalsec)=&GemX::ConvertSecToMin($totallength);
			IRC::print("Playing #".($songnum+1)."/$listlength: $song ($percent% of $totalmin:$totalsec) [\002$bitrate\002kbit/s \002$samplerate\002kHz]") if (GemX::GetGlobalSet("LANGUAGE") eq "EN");
			IRC::print("Spiele #".($songnum+1)."/$listlength: $song ($percent% of $totalmin:$totalsec) [\002$bitrate\002kbit/s \002$samplerate\002kHz]") if (GemX::GetGlobalSet("LANGUAGE") eq "DE");
		}
	} elsif ($cmd eq "NEXT") {
		$remote->playlist_next;
	} elsif ($cmd eq "PREV") {
		$remote->playlist_prev;
	} elsif ($cmd eq "PLAY") {
		$remote->play;
	} elsif ($cmd eq "PAUSE") {
		$remote->pause;
	} elsif ($cmd eq "FADEOUTANDSTOP" || $cmd eq "STOP") {
		$remote->stop;
		IRC::print("$gx::sol XMMS stopped.....") if (GemX::GetGlobalSet("LANGUAGE") eq "EN");
		IRC::print("$gx::sol XMMS gestoppt.....") if (GemX::GetGlobalSet("LANGUAGE") eq "DE");
	} else {
		IRC::print("$gx::sol XMMS: Invalid or Unsupported command!") if (GemX::GetGlobalSet("LANGUAGE") eq "EN");
		IRC::print("$gx::sol XMMS: Ungültiges oder nicht unterstütztes Kommando!") if (GemX::GetGlobalSet("LANGUAGE") eq "DE");
	}
	return 1;
}

sub gx::get_os {
	my ($version);
	open(VERSION, "uname -sr|");
	$version = <VERSION>;
	chomp $version;
	close VERSION;
	return $version;
}

sub gx::get_up {
	open(UPTIME, "</proc/uptime") or die Xchat::print("ERROR: could not find \'uptime'\ in your path");
	my @foo = <UPTIME>;
	my @uptime = split /\s+/, $foo[0];
	close UPTIME;
	return $uptime[0];
}
